API Docs

API Documentation

GET /api/catalog/packages

Retrieves version and compatibility data for OSS components.


Query Parameters

NameTypeDescription
pagestringOptional Page number (1-indexed)
sizestringOptional Number of results per page (default 25)
typestringOptional Filter by type (e.g. npm, maven)
namespacestringOptional Filter by namepsace (e.g. @angular)
namestringOptional Filter by name (e.g. passport)
versionstringOptional Filter by version (e.g. 2.2.0)
cvestringOptional Filter by CVE (e.g. CVE-2022-22976)
apistringOptional Request a specific version of API (e.g. 1.0.0)

Available API Versions

  • 1.0.0

Response Example

{
  "version": "1.0.0",
  "totalPages": 21,
  "page": 1,
  "results": [
    {
      "versions": [
        {
          "nes": {
            "purl": "pkg:npm/@neverendingsupport/passport",
            "latest": "0.2.2-passport-0.2.3",
            "versions": [
              {
                "name": "pkg:npm/@neverendingsupport/passport@0.2.2-passport-0.2.3",
                "purl": "pkg:npm/@neverendingsupport/passport@0.2.2-passport-0.2.3",
                "latest": true,
                "version": "0.2.2-passport-0.2.3"
              }
            ]
          },
          "oss": {
            "compatibility": [
              {
                "lower": "0.2.0",
                "upper": "0.2.2"
              }
            ],
            "forkPoint": "0.2.2"
          },
          "cves": [
            "CVE-2022-22976"
          ],
          "version": "0.2.2",
          "products": [
            "NES for PassportJS"
          ]
        }
      ],
      "component": "pkg:npm/passport"
    }
  ]
}

Response Properties

PropertyTypeDescription
versionstringString representing the version of the response
pagestringCurrent page of results
totalPagesstringTotal number of pages available for the results
resultsarrayArray of results, each representing a component and its associated versions
results[].componentstringPackage URL (purl) of the OSS component
results[].versionsarrayList of version objects for the component
versions[].versionstringHerodevs version for the entry
versions[].productsarrayArray of Herodevs products that contain this version
versions[].cvesarrayArray of CVEs that are associated with this version
versions[].nesNESObjectInfo from Never-Ending Support (fork)
versions[].ossOSSObjectInfo from the original open source (OSS) project

NESObject

PropertyTypeDescription
purlstringPackage URL of the NES package
lateststringLatest NES version
versionsarrayArray of specific NES versions
urlsNESUrlsInfo about related URLS
versions[].namestringFully qualified version name with purl
versions[].purlstringPackage URL of the specific NES version
versions[].latestbooleanWhether this is the latest version
versions[].versionstringVersion string

OSSObject

PropertyTypeDescription
compatibilityarrayCompatible OSS version ranges, this is a range you can update to the NES version from with limited effort.
compatibility[].lowerstringLower bound of compatible OSS versions
compatibility[].upperstringUpper bound of compatible OSS versions
forkPointstringOSS version where the fork occurred

NESUrls

PropertyTypeDescription
mainstringUrl pointing to HeroDevs marketing page associated with the package